--------------------------------------------------------------------------------
-- Carnage Contest "Armor dm" Game Mode Script
-- by Vectar666
--------------------------------------------------------------------------------
--doing some presetup
if cc==nil then cc={} end
cc.armor={}
cc.armor.crate={}
math.randomseed(getframe()*12345*getframesleft()*666) -- Mwahahaha!
armor_drop_timer=math.random(200,2000)

armorcrategfx=loadgfx("buildings/block.bmp")
setmidhandle(armorcrategfx)

armorcratesfx=loadsfx("supplyland.ogg")
armorcratesfx2=loadsfx("supplyincoming.ogg")
armorcratesfx3=loadsfx("supplycollect.ogg")
armorsfx=loadsfx("armor_hit.wav")

armorgfx={}
for i=1,5 do
	armorgfx[i]=loadgfx("armor/armor_"..i..".png")
	setmidhandle(armorgfx[i])
end

armorvalue={}
for i=1,100 do
	armorvalue[i]=0
end

armor_protection=50 --how much % does armor protect?
armor_durability=25 --how much armor reduces with health? (%)

addgamemode("armordm","Armoured Deathmatch")

function armordm_gm_start()

math.randomseed(getframe()*12345*getframesleft()*666) -- Mwahahaha!
armor_drop_timer=math.random(200,2000)

armorcrategfx=loadgfx("buildings/block.bmp")
setmidhandle(armorcrategfx)

armorcratesfx=loadsfx("supplyland.ogg")
armorcratesfx2=loadsfx("supplyincoming.ogg")
armorcratesfx3=loadsfx("supplycollect.ogg")
armorsfx=loadsfx("armor_hit.wav")

armorgfx={}
for i=1,5 do
	armorgfx[i]=loadgfx("armor/armor_"..i..".png")
	setmidhandle(armorgfx[i])
end

armorvalue={}
for i=1,100 do
	armorvalue[i]=0
end

end

function armordm_gm_draw()
	-- Drawing armor on cc guys if they have armor, picture is affected by armor value.
	local plrt=playertable(0,0)
	for i=1,#plrt do
		--if armorvalue==nil then armorvalue={} end
		--if armorvalue[plrt[i]]==nil then armorvalue[plrt[i]]=0 end
		if armorvalue[plrt[i]]>0 then
			-- Setup draw mode
			setblend(blend_alpha)
			setalpha(1)
			setcolor(255,255,255)
			setscale((getplayerdirection(plrt[i])*1.1),1.1)
			setrotation(0)
			-- Draw
			local part=math.ceil(armorvalue[plrt[i]]/20)
			if part>5 then part=5 end
			drawimage(armorgfx[part],getplayerx(plrt[i]),getplayery(plrt[i])+6) --armor with armor bar (1-5)
		end
	end
end

function armordm_gm_update()
	-- there goes rndtimered spawning of armor objects/crates
	-- timer
	armor_drop_timer=armor_drop_timer-1
	if armor_drop_timer<=0 then
	-- spawning
	math.randomseed(12345*getframesleft()*666)
	createobject(cc.armor.crate.id,math.random(0,getmapwidth()),-100)
	playsound(armorcratesfx2)
	-- randomize timer
	math.randomseed(getframe()*12345*getframesleft()*666)
	armor_drop_timer=math.random(1000,3000)
	end
end

function armordm_gm_playerdamage(id,dmg)
	--damage is lowering if player wears armor.
	if armorvalue[id]>0 then
		armorvalue[id]=armorvalue[id]-dmg*armor_durability/100
		--armor hit sound
		playsound(armorsfx)
		return dmg*(100-armor_protection)/100
	end
	--yeah, that's so simple
end

function armordm_gm_endturn()
	-- Let the game decide itself if it's over
	return -2
end

--------------------------------------------------------------------------------
-- Object: Armor Crate
--------------------------------------------------------------------------------

cc.armor.crate.id=addobject("cc.armor.crate",0)			-- Add Object

function cc.armor.crate.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].sy=0
end

function cc.armor.crate.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(55,200,55)
	setscale(1.1,1.1)
	setrotation(0)
	-- Draw
	drawimage(armorcrategfx,x,y)
end

function cc.armor.crate.update(id,x,y)
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()*0.7
	if objects[id].sy>100 then objects[id].sy=100 end
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(col20x20,x,y,1,0,1,-1,id)==1 then
			if (math.abs(objects[id].sy)>0.5) then playsound(armorcratesfx) end
			y=y-msuby
			objects[id].sy=0
			msuby=-msuby*0.3
		end
		if collision(col20x20,x,y,0,1,0) then
			if playercollision()>0 then
				armorvalue[playercollision()]=armorvalue[playercollision()]+20
				removeobject(id)
				particle(p_flare,x,y)
				particlecolor(0,200,0)
				particlesize(30,30)
				playsound(armorcratesfx3)
			end
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			return
		end
	end
	objectposition(id,x,y)
end

function cc.armor.crate.damage(id,damage)
	--do nothing, cus thats just a crate!
end